//----------- определения операций и их действий для всех типов ---------------------
typedef string (*op_func)( type_t, const string&, const string& ); 
class opers {                              // реализуемые вычислителем операции
   static map<string,op_func> ops;
   static string noop( void ) {
      throw syn_exception( "недопустимая операция для этого типа" );
      return "";                           // фиктивный возврат
   }    
public:
   static op_func find( const string& s ) {// поиск операции по её изображению 
      try { return ops.at( s ); }
      catch(...) { return NULL; }          // исключение если операция не найдена
   }
};
map<string,op_func> opers::ops = {
   { "<", []( type_t type, const string& o1, const string& o2 ) -> string {
             return ( 0 == type ? stoll( o1 ) < stoll( o2 ) : o1 < o2 ) ? "1" : "0"; 
          }
   },
   { ">", []( type_t type, const string& o1, const string& o2 ) -> string {
             return ( 0 == type ? stoll( o1 ) > stoll( o2 ) : o1 > o2 ) ? "1" : "0"; 
          }
   },
   { "+", []( type_t type, const string& o1, const string& o2 ) -> string {
             return 0 == type ? to_string( stoll( o1 ) + stoll( o2 ) ) : o1 + o2;
          } 
   },
   { "-", []( type_t type, const string& o1, const string& o2 ) -> string {
             return 0 == type ? to_string( stoll( o1 ) - stoll( o2 ) ) : noop();
          } 
   },
   { "*", []( type_t type, const string& o1, const string& o2 ) -> string {
             if( 0 == type ) 
                return to_string( stoll( o1 ) * stoll( o2 ) );
             int n = stoll( o2 );
             string sm( o2 );
             while( --n ) sm += o2;
             return sm;
          } 
   },
   { "/", []( type_t type, const string& o1, const string& o2 ) -> string {
             if( 0 == stoll( o2 ) )
                throw syn_exception( "деление на 0" );
             return 0 == type ? to_string( stoll( o1 ) / stoll( o2 ) ) : noop();
          } 
   },
   { "^", []( type_t type, const string& o1, const string& o2 ) -> string {
             if( type != 0 ) noop();          // не числовая операция
             long long n = stoll( o2 );
             if( n < 0 ) return "0";
             if( 0 == n ) return "1";
             long long p = stoll( o1 ), r = p;
             while( --n ) r *= p;
             return to_string( r );
          } 
   },
};
