#include "string.h"
#include <cstring>
//----------------------------- строчные функции --------------------------------
char* trim( char* s ) {                         // удаление обрамляюих пробелов
   char *ps = s, *es;
   while( isblank( *ps ) ) ps++;
   es = ps + strlen( ps ) - 1;
   while( isblank( *es ) ) *es-- = '\0';
   return ps;
}

string strtrim( const string& s ) {
   char cs[ s.length() + 1 ]; 
   strcpy( cs, s.c_str() );
   return string( trim( cs ) );
}

vector<string>& strsep( string& sourse, const string& delim ) {
   static vector<string> vs;
   vs.clear();
   char *pb = (char*)sourse.c_str();
   do {
      while( isblank( *pb ) ) pb++;             // удаление головных пробелов
      char *token = strsep( &pb, delim.c_str() );
      if( *token != 0 )                         // не пустая строка 
         vs.push_back( strtrim( string( token ) ) ); 
   } while( pb != NULL );    
   return vs;
}

ostream& operator <<( ostream& out, const vector<string>& vs ) {
   for( auto &s : vs )
      out << s << endl;
   return out;
}
//------------ предикаты тестирование записи (строки) на принадлежность ---------
bool test_var( const string& s ) {         // ... имя переменной
   auto p = s.begin();
   bool ret = isalpha( *p++ );
   while( ret && p != s.end() )
      ret = isalnum( *p++ );
   return ret;
}

bool test_int( const string& s ) {         // ... целочисленная константа
   const char *p = s.c_str();
   if( !*p ) return false;
   if( ( '+' == *p ) || ( '-' == *p ) ) p++;
   if( !*p ) return false;
   while( *p )
     if( !isdigit( *p++ ) )
        return false;
   return true;
}

bool test_string( const string& s ) {      // ... строчная константа
   return ( '\"' == *s.begin() ) &&
          ( '\"' == *( s.end() - 1 ) );
}
